/*
 * langues.h --- language package.
 *
 * Copyright (c) 1997-2002 by Pascal Wassong All Rights Reserved.
 *
 * Time-stamp: <2002-03-30 16:47:33 Pascal>
 *
 * This file is part of Natch.
 *
 * Natch is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Natch is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef	LANGUES_H
#define	LANGUES_H

typedef enum {eFrench, eEnglish, eGerman, numberOfLanguages} eLanguage;

typedef enum
{
	eStrEmpty,
	eStrCopyright,
	eStrInitialOfPieces,
	eStrForsytheInitials,
	eStrHalfMoves,
	eStrCoupsRestants,
	eStrRecherche,
	eStrPosition,
	eStrSolution,
	eStrSeeSolution,
	eStrStop,
	eStrSkip,
	eStrResolutionTime,
	eStrBeginResolution,
	eStrEndResolution,
	eStrStoppedBySolution,
	eStrStoppedByUser,
	eStrNumberOfWhiteMoves,
	eStrMove,
	eStrSolutionsFound,
	eStrContinueAt,
	eStrPositionSkipped,
	numberOfStrings
} eStringId;

typedef enum
{
	eCharEmpty,
	eCharYes,
	eCharNo,
	numberOfChars
} eCharId;

void				langSetLanguage(eLanguage langue);
char				langGetChar(eCharId charId);
const char* const	langGetString(eStringId stringId);

#endif	/* LANGUES_H */
